#include <stdio.h>

#include <propeller.h>


#define cSET 1
#define cGET 2

#define P16 1 << 16

#define STACKSIZE 20

typedef struct
{
	   unsigned char cCMD;
	   unsigned cPAR;
	   unsigned cCNT;
	   unsigned cINA;
	   unsigned cINB;
	   unsigned cOUTA;
	   unsigned cOUTB;
	   unsigned cDIRA;
	   unsigned cDIRB;
	   unsigned cCTRA;
	   unsigned cCTRB;
	   unsigned cFRQA;
	   unsigned cFRQB;
	   unsigned cPHSA;
	   unsigned cPHSB;
	   unsigned cVCFG;
	   unsigned cVSCL;
} _cogregister;

_cogregister cogreg[7];
int cog_id[8];
char Buffer [10];
static int cog1_stack[STACKSIZE];




void cTask ()
{

 	 unsigned char myCMD;
	 unsigned myID = __builtin_propeller_cogid() ;
	 myID--;
	 //DIRA |= P16;
	 for(;;)
	 {
	  		
			myCMD = cogreg[myID].cCMD;
			if(myCMD == 0)
			{
			   continue;
			}
			else if (myCMD == cSET)
			{
			   //PAR = cogreg[myID].cPAR ;  // read only
			   //CNT = cogreg[myID].cCNT ;  // read only
			   //INA = cogreg[myID].cINA ;  // read only
			   //INB = cogreg[myID].cINB ;  // read only
			   OUTA = cogreg[myID].cOUTA ;
			   OUTB = cogreg[myID].cOUTB ;
			   DIRA = cogreg[myID].cDIRA ;
			   DIRB = cogreg[myID].cDIRB ;
			   CTRA = cogreg[myID].cCTRA ;
			   CTRB = cogreg[myID].cCTRB ;
			   FRQA = cogreg[myID].cFRQA ;
			   FRQB = cogreg[myID].cFRQB ;
			   PHSA = cogreg[myID].cPHSA ;
			   PHSB = cogreg[myID].cPHSB ;
			   VCFG = cogreg[myID].cVCFG ;
			   VSCL = cogreg[myID].cVSCL ;
			   cogreg[myID].cCMD = 0;
			}
			else if (myCMD == cGET)
			{
			   //OUTA |= P16;
			   cogreg[myID].cPAR = PAR;
			   cogreg[myID].cCNT = CNT;
			   cogreg[myID].cINA = INA;
			   cogreg[myID].cINB = INB;
			   cogreg[myID].cOUTA = OUTA;
			   cogreg[myID].cOUTB = OUTB;
			   cogreg[myID].cDIRA = DIRA;
			   cogreg[myID].cDIRB = DIRB;
			   cogreg[myID].cCTRA = CTRA;
			   cogreg[myID].cCTRB = CTRB;
			   cogreg[myID].cFRQA = FRQA;
			   cogreg[myID].cFRQB = FRQB;
			   cogreg[myID].cPHSA = PHSA;
			   cogreg[myID].cPHSB = PHSB;
			   cogreg[myID].cVCFG = VCFG;
			   cogreg[myID].cVSCL = VSCL;
			   cogreg[myID].cCMD = 0;
			   //OUTA &= ~P16;
			}
			else
			  continue;
			  
			  
	 }
	 
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void start_lmm(void *func, int *stack_top, int i)
{
    extern unsigned int _load_start_kernel[];

    /* push the code address onto the stack */
    --stack_top;
    *stack_top = (int)func;

    /* now start the kernel */
    cog_id[i] = cognew(_load_start_kernel, stack_top);
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void sendhex (const char * reg, unsigned int hex)
{
	printf("%s: %08X\n",reg,hex);
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void main ()
{
	 int i;
	 unsigned int cmd;
	 unsigned int reg;
	 unsigned int adr;
	 unsigned int value;
	 
	 char * end = "..........";


	
	puts("CogView running . . .");
	
	for(i = 0; i < 7; i++)
	{
		start_lmm(cTask, cog1_stack + i*STACKSIZE,i);
		printf("cogreg[%d] -> cogid_%X started\n",i,cog_id[i]);
	}
	
monitor:
	puts(">> Enter a register index [0..7]");
	gets(Buffer);
	reg = atoi(Buffer);
	//printf("reg: %x\n",reg);

	puts(">> Enter a command [1... set a cogregister, 2... get cogregister]");
	gets(Buffer);
	cmd = atoi(Buffer);
	//printf("cmd: %x\n",cmd);
	
	
	
	if(cmd == 2)
	{
     cogreg[reg].cCMD = cGET;
	 //putchar('\n');
	 sendhex("PAR ",cogreg[reg].cPAR);
	 sendhex("CNT ",cogreg[reg].cCNT);
	 sendhex("INA ",cogreg[reg].cINA);
	 sendhex("INB ",cogreg[reg].cINB);
	 sendhex("OUTA",cogreg[reg].cOUTA);
	 sendhex("OUTB",cogreg[reg].cOUTB);
	 sendhex("DIRA",cogreg[reg].cDIRA);
	 sendhex("DIRB",cogreg[reg].cDIRB);
	 sendhex("CTRA",cogreg[reg].cCTRA);
	 sendhex("CTRB",cogreg[reg].cCTRB);
	 sendhex("FRQA",cogreg[reg].cFRQA);
	 sendhex("FRQB",cogreg[reg].cFRQB);
	 sendhex("PHSA",cogreg[reg].cPHSA);
	 sendhex("PHSB",cogreg[reg].cPHSB);
	 sendhex("VCFG",cogreg[reg].cVCFG);
	 sendhex("VSCL",cogreg[reg].cVSCL);
	}
	if(cmd == 1)
	{
	  puts(">> Enter register: 0..OUTA 1..DIRA 2..CTRA 3..CTRB 4..FRQA 5..FRQB 6..PHSA 7..PHSB");
	  gets(Buffer);
	  adr = atoi(Buffer);
	  //printf("adr: %X\n",adr);
	  puts("Enter value HEXADECIMAL !");
	  gets(Buffer);
	  value = strtol(Buffer,&end,16);
	  //printf("val: %X\n",value);	

	  if(adr == 0)
	  {
	   cogreg[reg].cOUTA = value;
	  }
	  if(adr == 1)
	  {
	   cogreg[reg].cDIRA = value;
	  }
	  if(adr == 2)
	  {
	   cogreg[reg].cCTRA = value;
	  }
	  if(adr == 3)
	  {
	   cogreg[reg].cCTRB = value;
	  }
	  if(adr == 4)
	  {
	   cogreg[reg].cFRQA = value;
	  }
	  if(adr == 5)
	  {
	   cogreg[reg].cFRQB = value;
	  }
	  if(adr == 6)
	  {
	   cogreg[reg].cPHSA = value;
	  }
	  if(adr == 7)
	  {
	   cogreg[reg].cPHSB = value;
	  }

	  cogreg[reg].cCMD = cSET;
	}


goto monitor;

}